
# TODO:
# 1. package some noarch bits separately: apidocs.

Summary: K Desktop Environment 4 - Libraries
Version: 3.94.0
Release: 2%{?dist}

%if 0%{?fedora} > 9
Name: kdelibs
Epoch: 6
Obsoletes: kdelibs4 < %{version}-%{release}
Provides:  kdelibs4 = %{version}-%{release}
%else
Name: kdelibs4
%endif

# LGPLv2: everything, except (see below)
# BSD: kdoctools/
# GFDL: kdoctools/customization ?
License: LGPLv2 and BSD
URL:     http://www.kde.org/
Group:   System Environment/Libraries
Source0: ftp://ftp.kde.org/pub/kde/unstable/%{version}/src/kdelibs-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# for macros.kde4
BuildRequires: kde-filesystem
Requires: hicolor-icon-theme
Requires: kde-filesystem
%{?_kde4_macros_api:Requires: kde4-macros(api) = %{_kde4_macros_api} }
Requires: shared-mime-info
#Requires: kde4-settings

Source1: kde4.sh
Source2: kde4.csh

# make -devel packages parallel-installable
Patch0: kdelibs-3.94.0-parallel-devel.diff
# fix kde#149703
Patch1: kdelibs-3.93.0-kde149703.diff
# fix kde#149705
Patch2: kdelibs-3.93.0-kde149705.diff
# upstream patch by Oswald Buddenhagen to fix unversioned kpty library
# SVN revision 724528
Patch3: kdelibs-3.94.0-version-kpty.diff

BuildRequires: qt4-devel >= 4.3.0
%global qt4_ver %(pkg-config QtCore --modversion 2>/dev/null || echo 4.3.0)
Requires: qt4 >= %{qt4_ver} 
Requires: xdg-utils
Requires(post): /sbin/ldconfig xdg-utils
Requires(postun): /sbin/ldconfig xdg-utils

BuildRequires: alsa-lib-devel
BuildRequires: aspell-devel
BuildRequires: avahi-devel
BuildRequires: bzip2-devel
BuildRequires: cmake
BuildRequires: cups-devel cups
BuildRequires: enchant-devel
BuildRequires: gamin-devel
BuildRequires: gettext-devel
BuildRequires: giflib-devel
# busted at least on x86_64
#BuildRequires: hspell-devel
BuildRequires: jasper-devel
BuildRequires: krb5-devel
BuildRequires: libacl-devel libattr-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libtiff-devel
BuildRequires: libxslt-devel libxml2-devel
BuildRequires: OpenEXR-devel
BuildRequires: openssl-devel
BuildRequires: pcre-devel
BuildRequires: shared-mime-info
BuildRequires: soprano-devel >= 1.95.0
BuildRequires: strigi-devel >= 0.5.5
BuildRequires: zlib-devel

%description
Libraries for the K Desktop Environment 4.
WARNING: This is a beta version. It probably has many bugs left.
Also, the API and ABI are NOT fully stable yet (soft freeze only).

%package devel
Group: Development/Libraries
Summary: Header files for compiling KDE 4 applications
Requires: %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
%if "%{name}" == "kdelibs4"
%else
Obsoletes: kdelibs4-devel < %{version}-%{release}
Provides:  kdelibs4-devel = %{version}-%{release}
%endif
Requires: qt4-devel
Requires: openssl-devel
Requires: bzip2-devel gamin-devel libacl-devel strigi-devel zlib-devel
## FIXME/TODO: trim these down  -- Rex
#Requires: libxslt-devel aspell-devel giflib-devel
#Requires: libpng-devel gettext-devel
#Requires: libtiff-devel pcre-devel libxml2-devel cups-devel libjpeg-devel
#Requires: krb5-devel
#Requires: alsa-lib-devel avahi-devel
%description devel
This package includes the header files you will need to compile
applications for KDE 4.
WARNING: This is a beta version. It probably has many bugs left.
Also, the API and ABI are NOT fully stable yet (soft freeze only).


%prep
%setup -q -n kdelibs-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p3


%build

mkdir -p %{_target_platform}
pushd %{_target_platform} 
%{cmake_kde4} ..
popd

make %{?_smp_mflags} -C %{_target_platform} VERBOSE=1

# FIXME/TODO: apidocs
# doc/api/doxygen.sh --doxdatadir=doc/common .


%install
rm -rf %{buildroot}

make install DESTDIR=%{buildroot} -C %{_target_platform}

# see also use-of/patching of XDG_MENU_PREFIX in kdebase
mv %{buildroot}%{_kde4_sysconfdir}/xdg/menus/applications.menu \
   %{buildroot}%{_kde4_sysconfdir}/xdg/menus/kde4-applications.menu

# remove files which conflict with KDE 3
rm -f %{buildroot}%{_kde4_bindir}/checkXML %{buildroot}%{_kde4_bindir}/kjscmd \
      %{buildroot}%{_kde4_bindir}/kunittestmodrunner
rm -f %{buildroot}%{_kde4_configdir}/kdebug.areas %{buildroot}%{_kde4_configdir}/kdebugrc \
      %{buildroot}%{_kde4_configdir}/kdeprintrc %{buildroot}%{_kde4_configdir}/ui/ui_standards.rc
rm -f %{buildroot}%{_kde4_docdir}/HTML/en/common/*
rm -f %{buildroot}%{_kde4_sharedir}/locale/all_languages

# move devel symlinks
mkdir -p %{buildroot}%{_kde4_libdir}/kde4/devel
pushd %{buildroot}%{_kde4_libdir}
for i in lib*.so
do
  case "$i" in
    libkdeinit4_*.so)
      ;;
    *)
      linktarget=`readlink "$i"`
      rm -f "$i"
      ln -sf "../../$linktarget" "kde4/devel/$i"
      ;;
  esac
done
popd

install -p -m 755 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/profile.d/kde4.sh
install -p -m 755 -D %{SOURCE2} %{buildroot}%{_sysconfdir}/profile.d/kde4.csh


%post
/sbin/ldconfig ||:
xdg-icon-resource forceupdate --theme hicolor 2> /dev/null || :
xdg-desktop-menu forceupdate 2> /dev/null || :

%postun 
/sbin/ldconfig ||:
xdg-icon-resource forceupdate --theme hicolor 2> /dev/null || :
xdg-desktop-menu forceupdate 2> /dev/null || :


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc AUTHORS README TODO
%doc COPYING COPYING-DOCS COPYING.LIB
%config(noreplace) %{_sysconfdir}/profile.d/*
%{_kde4_bindir}/*
%exclude %{_kde4_bindir}/kconfig_compiler4
%{_kde4_appsdir}/*
# kdewidgets
%exclude %{_kde4_bindir}/makekdewidgets4
%exclude %{_kde4_appsdir}/kdewidgets/
%exclude %{_kde4_libdir}/kde4/plugins/designer/kdewidgets.*
# ksgmltools2
%exclude %{_kde4_appsdir}/ksgmltools2/
%{_kde4_configdir}/*
%{_datadir}/dbus-1/interfaces/*
%{_kde4_datadir}/mime/packages/*
%{_kde4_sharedir}/kde4/services/*
%{_kde4_sharedir}/kde4/servicetypes/*
%{_kde4_sharedir}/icons/hicolor/*/actions/presence_*
%{_kde4_docdir}/HTML/en/*
%{_kde4_libdir}/lib*.so.*
%{_kde4_libdir}/libkdeinit4_*.so
%{_kde4_libdir}/kde4/
%exclude %{_kde4_libdir}/kde4/devel/
%{_kde4_sysconfdir}/xdg/menus/*.menu
%doc %{_mandir}/man*/*

%files devel
%defattr(-,root,root,-)
%doc KDE4PORTING.html
%{_kde4_bindir}/kconfig_compiler4
%{_kde4_bindir}/makekdewidgets4
%{_kde4_appsdir}/kdewidgets/
%dir %{_kde4_libdir}/kde4/plugins/designer
%{_kde4_libdir}/kde4/plugins/designer/kdewidgets.*
%{_kde4_appsdir}/ksgmltools2/
%{_kde4_includedir}/*
%{_kde4_libdir}/kde4/devel/


%changelog
* Thu Oct 18 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.94.0-2
- drop optional BR hspell-devel again due to broken x86_64 static library

* Thu Oct 18 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.94.0-1
- update to 3.94.0
- BR soprano-devel >= 1.95.0
- don't rename js to kjs after installation, fixed upstream
- update parallel-devel patch
- drop kde#149704 patch, fixed upstream
- drop colorscheme-hack patch
- backport upstream fix for unversioned kpty library (rev 724528)
- add new BRs hspell-devel and jasper-devel
- 3.94.0 generates some manpages, add them to the file list

* Thu Oct 4 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-11
- don't make this the default kdelibs on F9 yet
- retry ppc64 build (#300571)

* Fri Sep 21 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-10
- ExcludeArch: ppc64 (#300571)

* Thu Sep 20 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.93.0-9
- -devel: (re)add Requires: bzip2-devel gamin-devel libacl-devel strigi-devel zlib-devel
- update sources
- sync kde4.(sh|csh) changes wrt KDE_IS_PRELINKED w/ devel/ branch

* Fri Sep 14 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-8
- rename js to kjs because of file conflict (kde#149840)

* Thu Sep 13 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-7
- actually install kde4.sh and kde4.csh
- sync KDE_IS_PRELINKED setting in kde4.sh and kde4.csh with kdelibs 3
  (workaround for #244065 no longer needed, fixed in 3.93.0)

* Thu Sep 13 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-6
- set QT_PLUGIN_PATH in kde4.sh and kde4.csh

* Wed Sep 12 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-5
- fix strange coloring due to incomplete changes to KColorScheme

* Mon Sep 10 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-4
- use upstream fix (by David Faure) for kde#149704

* Mon Sep 10 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-3
- fix kde#149703, kde#149704, kde#149705

* Sun Sep 9 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-2
- remove files which conflict with KDE 3
- rename kconfig_compiler and makekdewidgets to *4
- move devel symlinks to %%{_kde4_libdir}/kde4/devel/
- drop Conflicts: kdelibs-devel

* Sun Sep 9 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.93.0-1
- update to 3.93.0
- drop kde4home patch (no longer applied)
- drop kdeprint soversion conflict patch (fixed upstream)
- remove icon-related code, pics/ is now in kdebase-runtime
- BR strigi-devel >= 0.5.5 due to API changes
- package hicolor presence_* icons which are not in hicolor-icon-theme
- don't list non-existing ksvgtopng in devel binaries (now in kdebase-runtime)

* Tue Aug 14 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.92.0-4
- -devel: omit most (hopefully) extraneous Requires:
- use macros.kde4
- -devel: Conflicts: kdelibs-devel (in %%_bindir,%%_libdir)
- License clarification

* Fri Aug 03 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.92.0-3
- name kdelibs4, don't mess with %%_prefix (for now)
- move to -devel: checkXML, kconfig_compiler, (make)kdewidgets, ksgmltools2,
  ksvgtopng, kunittestmodrunner
- set KDE_IS_PRELINKED unconditionally (#244065)
- License: LGPLv2
- Requires: shared-mime-info

* Mon Jul 30 2007 Than Ngo <than@redhat.com> 3.92.0-2
- fix conlict with kde3
- add -DSYSCONF_INSTALL_DIR

* Sat Jul 28 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.92.0-1
- kde-3.92.0 (kde4-beta1)

* Thu Jul 19 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.91.0-6
- add missing epoch to main package Requires for -devel if name is kdelibs

* Tue Jul 17 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.91.0-5
- BR: soprano-devel
- prefix=/usr cleanups

* Wed Jul 11 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.91.0-4
- apply upstream bugfix for KatePart syntax highlighting (kde #145571)

* Thu Jun 29 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.91.0-3
- fix %%_sysconfdir for %%_prefix != /usr case.

* Thu Jun 28 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.91.0-2
- updated kde4home.diff
- CMAKE_BUILD_TYPE=RelWithDebInfo (we're already using %%optflags)

* Wed Jun 27 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.91.0-1
- kde-3.91.0
- CMAKE_BUILD_TYPE=debug 

* Sat Jun 23 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.90.1-3
- specfile cleanup (%%prefix issues mostly)

* Wed May 30 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.90.1-2
- add missing BR shared-mime-info

* Sun May 13 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.90.1-1
- update to 3.90.1
- drop backported upstream fixes already in 3.90.1
- bump cmake BR to 2.4.5 as required upstream now
- add BR strigi-devel, alsa-lib-devel, avahi-devel
- don't set execute bits by hand anymore, cmake has been fixed
- use multilibs in /opt/kde4

* Mon Mar 26 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-5
- apply upstream fixes to build with Qt 4.3 Beta

* Sat Mar 24 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-4
- restore minimum version requirements for cmake and qt4-devel
- drop visibility hack (no longer needed with latest qt4 package)
- don't set QT4DIR and PATH anymore, qdbuscpp2xml has been fixed
- apply upstream bugfixes:
- * khtml segfault fix
- * message box cancel button fix
- * kprocio received buffer truncation fix (backported)
- * KatePart keyboard shortcut (Ctrl+Right, Shift+Right) fix

* Mon Mar 05 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.80.3-3
- +eXecute perms for %%{_prefix}/lib/*

* Fri Feb 23 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-2
- apply upstream patch to fix klauncher crash
- hack around Qt 4 being built with no visibility support
- install Qt Designer plugin

* Wed Feb 21 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-1
- update to 3.80.3
- update and improve parallel-installability patch
- set QT4DIR and PATH so CMake's direct $QT4DIR/qdbuscpp2xml calls work
- move libkdeinit_*.so from -devel to main package
- symlink kde4-config into /usr/bin so it can be used for path setting

* Wed Nov 29 2006 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> 3.80.2-0.4.20061003svn
- dropped -DCMAKE_SKIP_RPATH=TRUE from cmake
- compiling with QA_RPATHS=0x0003; export QA_RPATHS

* Sun Nov 26 2006 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> 3.80.2-0.3.20061003svn
- Added foolishly dropped libjpeg-devel, zlib-devel, krb5-devel, libattr-devel again as BR

* Thu Nov 23 2006 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> 3.80.2-0.2.20061003svn
- parallel build support
- added -DCMAKE_SKIP_RPATH=TRUE to cmake to skip rpath
- dropped libjpeg-devel, zlib-devel, krb5-devel, libattr-devel as BR
- dropped duplicate libattr-devel in BR
- spec file cleanups and added clean up in %%install
- fixed missing dependency : libkdeinit_knotify.so

* Sat Oct 07 2006 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.2-0.1.20061003svn
- first Fedora RPM (parts borrowed from the OpenSUSE kdelibs 4 RPM and the Fedora kdelibs 3 RPM)
- apply parallel-installability patch
